﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace MvcBookmarkService
{
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Users",
                "users",
                new { controller = "Bookmark", action = "UserIndex" }
            );

            routes.MapRoute(
                "Tags",
                "tags",
                new { controller = "Bookmark", action = "TagIndex" }
            );

            routes.MapRoute(
                "Bookmarks",
                "bookmarks",
                new { controller = "Bookmark", action = "BookmarkIndex" }
            );

            routes.MapRoute(
                "BookmarksByTag",
                "tags/{tag}",
                new { controller = "Bookmark", action = "BookmarksByTagIndex", tag = "" }
            );

            routes.MapRoute(
                "BookmarksByUser",
                "users/{username}",
                new { controller = "Bookmark", action = "BookmarksByUserIndex", username = "" }
            );

            // default route
            routes.MapRoute(
                "Default",                                              
                "{controller}/{action}/{id}",                           
                new { controller = "Home", action = "Index", id = ""}  
            );
        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
        }
    }
}