﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;

namespace MvcBookmarkService
{
    public class UrlEncoder
    {
        public static string URLDecode(string decode)
        {
            if (decode == null) return null;
            if (decode.StartsWith("="))
            {
                return FromBase64(decode.TrimStart('='));
            }
            else
            {
                return decode.Replace("+", " ");
            }
        }

        public static string UrlEncode(string encode)
        {
            if (encode == null) return null;
            string encoded = HttpUtility.UrlEncode(encode);
            if (encoded.Replace("+", "") == encode.Replace(" ", ""))
            {
                return encoded;
            }
            else
            {
                return "=" + ToBase64(encode);
            }
        }

        public static string ToBase64(string encode)
        {
            Byte[] btByteArray = null;
            ASCIIEncoding encoding = new ASCIIEncoding();
            btByteArray = encoding.GetBytes(encode);
            string sResult = System.Convert.ToBase64String(btByteArray, 0, btByteArray.Length);
            sResult = sResult.Replace("+", "-").Replace("/", "_");
            return sResult;
        }

        public static string FromBase64(string decode)
        {
            decode = decode.Replace("-", "+").Replace("_", "/");
            ASCIIEncoding encoding = new ASCIIEncoding();
            return encoding.GetString(Convert.FromBase64String(decode));
        }
    }
}
